//-----------------------------------------------------------------------------
// Project            	GeometryKit
// Class		G3DVector2d
// Creator            	Philippe C.D. Robert
// Maintainer         	Philippe C.D. Robert
// Creation Date      	Thu Sep  9 11:05:08 CEST 1999
//
// Copyright (c) Philippe C.D. Robert
//
// The GeometryKit is free software; you can redistribute it and/or modify it 
// under the terms of the GNU LGPL Version 2 as published by the Free 
// Software Foundation
//
// $Id: G3DVector2d.h,v 1.5 2001/01/05 20:50:49 robert Exp $
//-----------------------------------------------------------------------------

#ifndef __G3DVector2d_h_INCLUDE
#define __G3DVector2d_h_INCLUDE

#import <Foundation/Foundation.h>
#import <GeometryKit/G3DTuple2d.h>

@interface G3DVector2d : G3DTuple2d
{
}

//-----------------------------------------------------------------------------
// Class methods
//-----------------------------------------------------------------------------

+ (G3DVector2d *)vector2d;
+ (G3DVector2d *)vector2dWithValues:(double *)vals;
+ (G3DVector2d *)vector2dWithX:(double)x y:(double)y;
+ (G3DVector2d *)vector2dWithVector2d:(G3DVector2d *)vec;

//-----------------------------------------------------------------------------
// init and free
//-----------------------------------------------------------------------------

- (id)initWithVector:(G3DVector2d *)vec;

//-----------------------------------------------------------------------------
// Math
//-----------------------------------------------------------------------------

- (G3DVector2d *)vectorByAdding:(G3DVector2d *)aVector;
- (G3DVector2d *)vectorBySubtracting:(G3DVector2d *)aVector;

- (G3DVector2d *)vectorByMultiplyingBy:(double)aScalar;
- (G3DVector2d *)vectorByDividingBy:(double)aScalar;

- (double)dotProduct:(G3DVector2d *)aVec;

- (double)length;

- (double)squaredLength;

- (void)normalise;

- (G3DVector2d *)normalisedVector;

@end

#endif







